import React from 'react';

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function useAsyncDebounce(defaultFn) {
  var defaultWait = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var debounceRef = React.useRef({});
  debounceRef.current.defaultFn = defaultFn;
  debounceRef.current.defaultWait = defaultWait;
  var debounce = React.useCallback(
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    var fn,
        wait,
        _args2 = arguments;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            fn = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : debounceRef.current.defaultFn;
            wait = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : debounceRef.current.defaultWait;

            if (!debounceRef.current.promise) {
              debounceRef.current.promise = new Promise(function (resolve) {
                debounceRef.current.resolve = resolve;
              });
            }

            if (debounceRef.current.timeout) {
              clearTimeout(debounceRef.current.timeout);
            }

            debounceRef.current.timeout = setTimeout(
            /*#__PURE__*/
            _asyncToGenerator(
            /*#__PURE__*/
            regeneratorRuntime.mark(function _callee() {
              return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      delete debounceRef.current.timeout;
                      _context.prev = 1;
                      _context.t0 = debounceRef.current;
                      _context.next = 5;
                      return fn();

                    case 5:
                      _context.t1 = _context.sent;

                      _context.t0.resolve.call(_context.t0, _context.t1);

                      _context.next = 12;
                      break;

                    case 9:
                      _context.prev = 9;
                      _context.t2 = _context["catch"](1);
                      debounceRef.current.reject(_context.t2);

                    case 12:
                      _context.prev = 12;
                      delete debounceRef.current.promise;
                      return _context.finish(12);

                    case 15:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee, null, [[1, 9, 12, 15]]);
            })), wait);
            return _context2.abrupt("return", debounceRef.current.promise);

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })), []);
  return debounce;
}

var formContext = React.createContext();

function makeState(decor) {
  return _objectSpread({
    meta: {
      isSubmitting: false,
      isTouched: false,
      isSubmitted: false,
      submissionAttempts: 0
    },
    __fieldMeta: {}
  }, decor);
}

var defaultDefaultValue = {};
function useForm(_ref) {
  var onSubmit = _ref.onSubmit,
      _ref$defaultValues = _ref.defaultValues,
      defaultValues = _ref$defaultValues === void 0 ? defaultDefaultValue : _ref$defaultValues,
      validate = _ref.validate,
      validatePristine = _ref.validatePristine,
      debug = _ref.debug;

  var _React$useState = React.useState(function () {
    return makeState({
      values: defaultValues
    });
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      _React$useState2$ = _React$useState2[0],
      values = _React$useState2$.values,
      meta = _React$useState2$.meta,
      __fieldMeta = _React$useState2$.__fieldMeta,
      setState = _React$useState2[1];

  var _meta = meta,
      isSubmitting = _meta.isSubmitting,
      isTouched = _meta.isTouched; // Can we submit this form?

  var isValid = isTouched && !someObject(__fieldMeta, function (field) {
    return field && field.error;
  }) && !meta.error;
  var canSubmit = isValid && !isSubmitting; // Decorate form meta

  meta = React.useMemo(function () {
    return _objectSpread({}, meta, {
      isValid: isValid,
      canSubmit: canSubmit
    });
  }, [canSubmit, meta, isValid]);
  var apiRef = React.useRef(); // We want the apiRef to change every time state updates

  apiRef.current = React.useMemo(function () {
    return {
      values: values,
      meta: meta,
      __fieldMeta: __fieldMeta,
      debug: debug
    };
  }, [debug, __fieldMeta, meta, values]);
  var metaRef = React.useRef({});

  var __fieldMetaRefsRef = React.useRef({});

  apiRef.current.__fieldMetaRefs = __fieldMetaRefsRef.current;
  apiRef.current.onSubmit = onSubmit;
  apiRef.current.reset = React.useCallback(function () {
    setState(function () {
      return makeState({
        values: defaultValues
      });
    });
  }, [defaultValues, setState]); // On submit

  apiRef.current.handleSubmit = React.useCallback(
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(e) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              e.persist();
              e.preventDefault(); // This lets sub-forms with form elements (despite them being invalid HTML)
              // handle submissions without triggering parent forms

              if (!e.__handled) {
                _context.next = 4;
                break;
              }

              return _context.abrupt("return");

            case 4:
              e.__handled = true;
              apiRef.current.setMeta(function (old) {
                return _objectSpread({}, old, {
                  // Submission attempts make the form dirty
                  isTouched: true,
                  // Submittion attempts mark the form as not submitted
                  isSubmitted: false,
                  // Count submission attempts
                  submissionAttempts: old.submissionAttempts + 1
                });
              }); // Don't allow isSubmitting

              if (!apiRef.current.meta.isSubmitting) {
                _context.next = 8;
                break;
              }

              return _context.abrupt("return");

            case 8:
              apiRef.current.setMeta({
                isSubmitting: true
              });
              _context.prev = 9;
              _context.next = 12;
              return apiRef.current.onSubmit(apiRef.current.values, apiRef.current);

            case 12:
              apiRef.current.setMeta({
                isSubmitted: true
              });
              _context.next = 18;
              break;

            case 15:
              _context.prev = 15;
              _context.t0 = _context["catch"](9);
              throw _context.t0;

            case 18:
              _context.prev = 18;
              apiRef.current.setMeta({
                isSubmitting: false
              });
              return _context.finish(18);

            case 21:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[9, 15, 18, 21]]);
    }));

    return function (_x) {
      return _ref2.apply(this, arguments);
    };
  }(), []);
  var validateRef = React.useRef();
  validateRef.current = validate; // Create a debounce for this field hook instance (not all instances)

  apiRef.current.debounce = useAsyncDebounce();
  apiRef.current.setMeta = React.useCallback(function (updater) {
    setState(function (old) {
      return _objectSpread({}, old, {
        meta: typeof updater === 'function' ? updater(old.meta) : _objectSpread({}, old.meta, updater)
      });
    });
  }, [setState]);
  apiRef.current.runValidation = React.useCallback(
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2() {
    var id, checkLatest, error;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (validateRef.current) {
              _context2.next = 2;
              break;
            }

            return _context2.abrupt("return");

          case 2:
            apiRef.current.setMeta({
              validating: true
            }); // Use the validationCount for all field instances to
            // track freshness of the validation

            id = (metaRef.current.validationCount || 0) + 1;
            metaRef.current.validationCount = id;

            checkLatest = function checkLatest() {
              return id === metaRef.current.validationCount;
            };

            _context2.next = 8;
            return validateRef.current(apiRef.current.values, apiRef.current);

          case 8:
            error = _context2.sent;

            if (checkLatest()) {
              apiRef.current.setMeta({
                validating: false
              });

              if (typeof error !== 'undefined') {
                if (error) {
                  if (typeof error === 'string') {
                    apiRef.current.setMeta({
                      error: error
                    });
                  }
                } else {
                  apiRef.current.setMeta({
                    error: null
                  });
                }
              }
            }

          case 10:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })), []); // When the form gets dirty and when the value changes
  // validate

  React.useEffect(function () {
    if (!validatePristine && !isTouched) {
      return;
    }

    apiRef.current.runValidation(values);
  }, [isTouched, validatePristine, values]);
  apiRef.current.getFieldValue = React.useCallback(function (field) {
    return getBy(apiRef.current.values, field);
  }, []);
  apiRef.current.getFieldMeta = React.useCallback(function (field) {
    var fieldID = getFieldID(field);
    return apiRef.current.__fieldMeta[fieldID];
  }, []);
  apiRef.current.__getFieldMetaRef = React.useCallback(function (field) {
    var fieldID = getFieldID(field);

    if (!apiRef.current.__fieldMetaRefs[fieldID]) {
      apiRef.current.__fieldMetaRefs[fieldID] = {
        current: {}
      };
    }

    return apiRef.current.__fieldMetaRefs[field];
  }, []);
  apiRef.current.setFieldMeta = React.useCallback(function (field, updater) {
    var fieldID = getFieldID(field);
    setState(function (old) {
      return _objectSpread({}, old, {
        __fieldMeta: _objectSpread({}, old.__fieldMeta, _defineProperty({}, fieldID, typeof updater === 'function' ? updater(old.__fieldMeta[fieldID]) : _objectSpread({}, old.__fieldMeta[fieldID], updater)))
      });
    });
  }, [setState]);
  apiRef.current.setFieldValue = React.useCallback(function (field, updater) {
    var _ref4 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
        _ref4$isTouched = _ref4.isTouched,
        isTouched = _ref4$isTouched === void 0 ? true : _ref4$isTouched;

    setState(function (old) {
      return _objectSpread({}, old, {
        values: setBy(old.values, field, typeof updater === 'function' ? updater(getBy(old.values, field)) : updater)
      });
    });

    if (isTouched) {
      apiRef.current.setFieldMeta(field, {
        isTouched: true
      });
      apiRef.current.setMeta({
        isTouched: true
      });
    }
  }, [setState]);
  apiRef.current.pushFieldValue = React.useCallback(function (field, value, options) {
    apiRef.current.setFieldValue(field, function (old) {
      if (Array.isArray(old)) {
        old.push(value);
      } else {
        throw Error("Cannot push a field value into a non-array field. Check that this field's existing value is an array: ".concat(field, "."));
      }
    }, options);
  }, []);
  apiRef.current.insertFieldValue = React.useCallback(function (field, index, value, options) {
    apiRef.current.setFieldValue(field, function (old) {
      if (Array.isArray(old)) {
        old.splice(index, 0, value);
      } else {
        throw Error("Cannot insert a field value into a non-array field. Check that this field's existing value is an array: ".concat(field, "."));
      }
    }, options);
  }, []);
  apiRef.current.removeFieldValue = React.useCallback(function (field, key, options) {
    apiRef.current.setFieldValue(field, function (old) {
      if (Array.isArray(old)) {
        old.splice(key, 0);
      } else {
        throw Error("Cannot remove a field value from a non-array field. Check that this field's existing value is an array: ".concat(field, "."));
      }
    }, options);
  }, []);
  apiRef.current.swapFieldValues = React.useCallback(function (path, index1, index2) {
    setState(function (old) {
      var old1 = getBy(old.values, [path, index1]);
      var old2 = getBy(old.values, [path, index2]);
      var values = setBy(old.values, [path, index1], old2);
      values = setBy(values, [path, index2], old1);
      return _objectSpread({}, old, {
        values: values
      });
    });
  }, [setState]);
  apiRef.current.setValues = React.useCallback(function (values) {
    setState(function (old) {
      return _objectSpread({}, old, {
        values: values
      });
    });
  }, [setState]); // When defaultValues update, set them

  React.useEffect(function () {
    if (defaultValues !== apiRef.current.values) {
      setState(function (old) {
        return _objectSpread({}, old, {
          values: defaultValues
        });
      });
    }
  }, [defaultValues, setState]);
  var FormRef = React.useRef();

  if (!FormRef.current) {
    FormRef.current = makeForm();
  } // Pass the full context to the form element


  apiRef.current.Form = FormRef.current;
  apiRef.current.Form.contextValue = apiRef.current; // Return the root form and the Form component to the hook user

  return apiRef.current;
}
function useFormContext() {
  var formApi = React.useContext(formContext);

  if (!formApi) {
    throw new Error("You are trying to use the form API outside of a form!");
  }

  return formApi;
}
var methodMap = ['setFieldValue', 'setFieldMeta', 'pushFieldValue', 'insertFieldValue', 'removeFieldValue', 'swapFieldValues'];
var defaultDefaultMeta = {};
function useField(fieldName) {
  var _ref5 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      defaultValue = _ref5.defaultValue,
      _ref5$defaultIsTouche = _ref5.defaultIsTouched,
      defaultIsTouched = _ref5$defaultIsTouche === void 0 ? false : _ref5$defaultIsTouche,
      _ref5$defaultError = _ref5.defaultError,
      defaultError = _ref5$defaultError === void 0 ? null : _ref5$defaultError,
      _ref5$defaultMeta = _ref5.defaultMeta,
      defaultMeta = _ref5$defaultMeta === void 0 ? defaultDefaultMeta : _ref5$defaultMeta,
      validatePristine = _ref5.validatePristine,
      validate = _ref5.validate;

  if (!fieldName) {
    throw new Error("useField: A field is required to use this hook. eg, useField('myField', options)");
  }

  var formApi = useFormContext(); // Support field prefixing from FieldScope

  var fieldPrefix = '';

  if (formApi.fieldName) {
    // This is okay because any `.[`'s will get replace to just `.`
    fieldPrefix = "".concat(formApi.fieldName, ".");
    formApi = formApi.form;
  }

  fieldName = fieldPrefix + fieldName;
  var formApiRef = React.useRef();
  var apiRef = React.useRef({}); // An escape hatch for accessing latest formAPI

  formApiRef.current = formApi;
  var preValue = formApi.getFieldValue(fieldName);
  var preMeta = formApi.getFieldMeta(fieldName);

  var __metaRef = formApi.__getFieldMetaRef(fieldName); // Let's scope some field-level methods for convenience


  var _methodMap$map = methodMap.map(function (d) {
    // Since this array is stable and always the same, we can disable
    // the react-hooks linter here:
    // eslint-disable-next-line
    return React.useCallback(function () {
      var _formApiRef$current;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return (_formApiRef$current = formApiRef.current)[d].apply(_formApiRef$current, [fieldName].concat(args));
    }, // eslint-disable-next-line
    [fieldName]);
  }),
      _methodMap$map2 = _slicedToArray(_methodMap$map, 6),
      setValue = _methodMap$map2[0],
      setMeta = _methodMap$map2[1],
      pushValue = _methodMap$map2[2],
      insertValue = _methodMap$map2[3],
      removeValue = _methodMap$map2[4],
      swapValues = _methodMap$map2[5]; // Let's scope some field-level methods for convenience


  var _methodMap$map3 = methodMap.map(function (d) {
    // Since this array is stable and always the same, we can disable
    // the react-hooks linter here:
    // eslint-disable-next-line
    return React.useCallback(function (subField) {
      var _formApiRef$current2;

      for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      return (_formApiRef$current2 = formApiRef.current)[d].apply(_formApiRef$current2, ["".concat(fieldName, ".").concat(subField)].concat(args));
    }, // eslint-disable-next-line
    [fieldName]);
  }),
      _methodMap$map4 = _slicedToArray(_methodMap$map3, 6),
      setFieldValue = _methodMap$map4[0],
      setFieldMeta = _methodMap$map4[1],
      pushFieldValue = _methodMap$map4[2],
      insertFieldValue = _methodMap$map4[3],
      removeFieldValue = _methodMap$map4[4],
      swapFieldValues = _methodMap$map4[5]; // Handle default values


  var value = React.useMemo(function () {
    return typeof preValue === 'undefined' && typeof defaultValue !== 'undefined' ? defaultValue : preValue;
  }, [defaultValue, preValue]);
  React.useLayoutEffect(function () {
    if (typeof preValue === 'undefined') {
      setValue(value, {
        isTouched: false
      });
    }
  }, [preValue, setValue, value]); // Handle default meta

  var meta = React.useMemo(function () {
    return typeof preMeta === 'undefined' ? _objectSpread({
      error: defaultError,
      isTouched: defaultIsTouched
    }, defaultMeta) : preMeta;
  }, [defaultError, defaultMeta, defaultIsTouched, preMeta]);
  React.useLayoutEffect(function () {
    if (typeof preMeta === 'undefined') {
      setMeta(meta);
    }
  }, [meta, preMeta, setMeta, setValue, value]);
  apiRef.current = React.useMemo(function () {
    return {
      value: value,
      meta: meta,
      form: formApi,
      fieldName: fieldName
    };
  }, [fieldName, formApi, meta, value]);
  Object.assign(apiRef.current, {
    __metaRef: __metaRef,
    setValue: setValue,
    setMeta: setMeta,
    pushValue: pushValue,
    insertValue: insertValue,
    removeValue: removeValue,
    swapValues: swapValues,
    setFieldValue: setFieldValue,
    setFieldMeta: setFieldMeta,
    pushFieldValue: pushFieldValue,
    insertFieldValue: insertFieldValue,
    removeFieldValue: removeFieldValue,
    swapFieldValues: swapFieldValues
  });
  var validateRef = React.useRef();
  validateRef.current = validate; // Create a debounce for this field hook instance (not all instances)

  apiRef.current.debounce = useAsyncDebounce();
  apiRef.current.runValidation = React.useCallback(
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee3() {
    var id, checkLatest, error;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (validateRef.current) {
              _context3.next = 2;
              break;
            }

            return _context3.abrupt("return");

          case 2:
            setMeta({
              validating: true
            }); // Use the validationCount for all field instances to
            // track freshness of the validation

            id = (__metaRef.current.validationCount || 0) + 1;
            __metaRef.current.validationCount = id;

            checkLatest = function checkLatest() {
              return id === __metaRef.current.validationCount;
            };

            _context3.next = 8;
            return validateRef.current(apiRef.current.value, apiRef.current);

          case 8:
            error = _context3.sent;

            if (checkLatest()) {
              setMeta({
                validating: false
              });

              if (typeof error !== 'undefined') {
                if (error) {
                  if (typeof error === 'string') {
                    setMeta({
                      error: error
                    });
                  }
                } else {
                  setMeta({
                    error: null
                  });
                }
              }
            }

          case 10:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })), [__metaRef, setMeta]); // When the form gets dirty and when the value changes
  // validate

  React.useEffect(function () {
    if (!validatePristine && !meta.isTouched) {
      return;
    }

    apiRef.current.runValidation(value);
  }, [meta.isTouched, validatePristine, value]);
  var FieldScopeRef = React.useRef(); // Provide a FieldScope for nested field syntax

  if (!FieldScopeRef.current) {
    FieldScopeRef.current = makeField();
  }

  apiRef.current.FieldScope = FieldScopeRef.current;
  apiRef.current.FieldScope.contextValue = apiRef.current;
  return apiRef.current;
}

function makeForm() {
  return function Form(_ref7) {
    var children = _ref7.children,
        noFormElement = _ref7.noFormElement,
        rest = _objectWithoutProperties(_ref7, ["children", "noFormElement"]);

    var _Form$contextValue = Form.contextValue,
        handleSubmit = _Form$contextValue.handleSubmit,
        isSubmitting = _Form$contextValue.meta.isSubmitting,
        debug = _Form$contextValue.debug;
    return React.createElement(formContext.Provider, {
      value: Form.contextValue
    }, noFormElement ? children : React.createElement("form", _extends({
      onSubmit: handleSubmit,
      disabled: isSubmitting
    }, rest), children, debug ? React.createElement("pre", null, React.createElement("code", null, JSON.stringify(Form.contextValue, null, 2))) : null));
  };
}

function makeField() {
  return function Field(_ref8) {
    var children = _ref8.children;
    return React.createElement(formContext.Provider, {
      value: Field.contextValue
    }, children);
  };
}

function splitFormProps(_ref9) {
  var field = _ref9.field,
      defaultValue = _ref9.defaultValue,
      defaultIsTouched = _ref9.defaultIsTouched,
      defaultError = _ref9.defaultError,
      defaultMeta = _ref9.defaultMeta,
      validatePristine = _ref9.validatePristine,
      validate = _ref9.validate,
      rest = _objectWithoutProperties(_ref9, ["field", "defaultValue", "defaultIsTouched", "defaultError", "defaultMeta", "validatePristine", "validate"]);

  return [{
    field: field,
    defaultValue: defaultValue,
    defaultIsTouched: defaultIsTouched,
    defaultError: defaultError,
    defaultMeta: defaultMeta,
    validatePristine: validatePristine,
    validate: validate
  }, rest];
} // Utils

function getBy(obj, path) {
  if (!path) {
    throw new Error('A path string is required to use getBy');
  }

  var pathArray = makePathArray(path);
  var pathObj = pathArray;
  return pathObj.reduce(function (current, pathPart) {
    if (typeof current !== 'undefined') {
      return current[pathPart];
    }

    return undefined;
  }, obj);
}

function setBy(obj, path, updater) {
  path = path.replace(/\[(\d*)\]/gm, '__int__$1').replace('[', '').replace(']', '.').replace(/\.{2,}/, '.').split('.').map(function (d) {
    if (d.indexOf('__int__') === 0) {
      return parseInt(d.substring('__int__'.length), 10);
    }

    return d;
  });

  function doSet(parent) {
    if (!path.length) {
      return typeof updater === 'function' ? updater(parent) : updater;
    }

    var key = path.shift();

    if (typeof key === 'string') {
      if (_typeof(parent) === 'object') {
        return _objectSpread({}, parent, _defineProperty({}, key, doSet(parent[key])));
      }

      return _defineProperty({}, key, doSet());
    }

    if (typeof key === 'number') {
      if (Array.isArray(parent)) {
        var prefix = parent.slice(0, key);
        return [].concat(_toConsumableArray(prefix.length ? prefix : new Array(key)), [doSet(parent[key])], _toConsumableArray(parent.slice(key + 1)));
      }

      return [].concat(_toConsumableArray(new Array(key)), [doSet()]);
    }

    throw new Error('Uh oh!');
  }

  return doSet(obj);
}

function getFieldID(str) {
  return str.replace('[', '.').replace(']', '').replace(/\.{2,}/gm, '.');
}

function makePathArray(str) {
  return str.replace(/\[(\d*)\]/gm, '__int__$1').replace('[', '.').replace(']', '').split('.').map(function (d) {
    if (d.indexOf('__int__') === 0) {
      return parseInt(d.substring('__int__'.length), 10);
    }

    return d;
  });
}

function loopObject(obj, fn, callback) {
  Object.keys(obj).forEach(function (key) {
    callback(fn(obj[key], key), key);
  });
}

function someObject(obj, fn) {
  var found = false;
  loopObject(obj, fn, function (result, key) {
    if (found) {
      return;
    }

    if (result) {
      found = true;
    }
  });
  return found;
}

export { splitFormProps, useField, useForm, useFormContext };
//# sourceMappingURL=index.es.js.map
